

' should be declared _before_ including "mision.bi"
Dim Shared Keys(0 To 127) As UByte

#Include "mision.bi"
#Include "radplay.bi"

' external data in data.o
Extern Sprites(0 To 45) Alias "SPRITES" As UByte Ptr Ptr
Extern Tiles(0 To 255, 0 To 15) Alias "TILES" As UByte
Extern Logo Alias "LOGO" As UByte
Extern Font(0 To 255, 0 To 15) Alias "FONT" As UByte
Extern StatusBars(0 To 6, 0 To 42) Alias "STATUSBAR1" As UByte
Extern Screens(0 To 91) As UByte Ptr
Extern Patterns(0 To 117) As UByte Ptr
Extern ScreenInfos(0 To 91) As UByte Ptr


Dim Shared As UByte ScreenTilesBuffer(0 To &h2a7) 
Dim Shared As UByte ship_cur_screen = 0
Dim Shared As UByte ScreenBuffer(0 To 320*200-1)


Declare Sub PutGeneric(As Integer, As Integer, As Integer, As Integer, As UByte Ptr)
Declare Sub PutSprite(As Integer, As Integer, As UByte Ptr)
Declare Sub PutTile(As Integer, As Integer, As UByte Ptr)
Declare Function AdjustAscii(As UByte) As UByte
Declare Sub PutLetter(As Integer, As Integer, As UByte)
Declare Sub PutString(As Integer, As Integer, As ZString Ptr)
Declare Sub PutStream(As Integer, As Integer, As UByte Ptr)

Declare Sub UnpackScreenToTileBuffer
Declare Sub TileBufferToScreen

Sub PutGeneric(x As Integer, y As Integer, xSize As Integer, ySize As Integer, p As UByte Ptr)

    Static As UByte smth(0 To 3) = {6, 4, 2, 0}
    Static As UByte CGA_Palette(0 To 3) = {0, 3, 5, 7}
    
    Static As Integer dx, dy

    For dy = 0 To ySize - 1
        For dx = 0 To xSize - 1
        	
            If x + dx >= 0 Then 
                If x + dx < 320 Then 
                    If y + dy >= 0 Then 
                        If y + dy < 200 Then
                       	 Poke((y + dy) * 320 + x + dx + @ScreenBuffer(0)), CGA_Palette((*p Shr smth(dx And 3)) And &h3)
                        End If
                    End If
                End If
            End If	
            If (dx And 3) = 3 Then p += 1
        Next	
    Next 	
End Sub

Sub PutBlank(x As Integer, y As Integer, p As UByte Ptr)
    Dim As Integer dx, dy, xsize, ysize
    
    xsize = *p * 4
    ysize = *(p + 1)
    For dy = 0 To ysize - 1
        For dx = 0 To xsize - 1
            If x + dx >= 0 Then 
                If x + dx < 320 Then 
                    If y + dy >= 0 Then 
                        If y + dy < 200 Then
                       	    Poke((y + dy) * 320 + x + dx + @ScreenBuffer(0)), 0
                        End If
                    End If
                End If
            End If	
        Next 
    Next 
End Sub

Sub PutSprite(x As Integer, y As Integer, p As UByte Ptr)
    PutGeneric x, y, *p Shl 2, *(p + 1), p + 2
End Sub

Sub PutTile(x As Integer, y As Integer, p As UByte Ptr)
    PutGeneric x, y, 8, 8, p
End Sub 

Dim Shared As ZString*16 infostring => "FPS: "

Sub word2string(ccc As Integer, buffer As UByte Ptr)
    Static As Integer _smth(0 To 4) = {10000, 1000, 100, 10, 1}
    
    Asm mov edi, [buffer]
    
    If ccc = 0 Then
        Asm mov Dword Ptr [edi], 0x002030
        Return
    End If
    
    Asm Xor esi, esi
    Asm jmp __end_loop
    Asm __beg_loop:
    
    Asm mov eax, [ccc]
    Asm Xor edx,edx
    Asm mov ecx, [_smth+esi*4]
    Asm div ecx
    Asm And edx, 0xffff
    Asm mov [ccc], edx
    
    Asm And eax, 0xff
    Asm mov ecx, edi
    Asm add ecx, eax
    Asm cmp [buffer], ecx
    Asm je __cont_loop
    
    Asm add al, 0x30
    Asm mov Byte Ptr [edi], al
    Asm Inc edi
    
    Asm __cont_loop:
    Asm Inc esi
    Asm __end_loop:
    Asm cmp esi, 5
    Asm jb __beg_loop
    Asm mov Dword Ptr [edi], 0x20
    
End Sub

Function AdjustAscii(a As UByte) As UByte
    If a <= &h5a Then
        If a >= &h41 Then Return a - &h41 + &hc
        If a = &h20 Then Return 0
        Return a - &h30 + 1
    End If
    Return 0
End Function

Sub PutLetter(x As Integer, y As Integer, a As UByte)
    PutGeneric x, y, 8, 8, @Font(a, 0)
End Sub  

Sub PutString(x As Integer, y As Integer, p As ZString Ptr)
    
    While Peek(p) <> 0
        PutLetter x, y, AdjustAscii(Peek(p))
        p += 1
        x += 8
    Wend 
End Sub 
Sub PutStream(x As Integer, y As Integer, p As UByte Ptr)
    
    While Peek(p) <> 0
        PutLetter x, y, Peek(p)
        p += 1
        x += 8
    Wend 
End Sub 

Sub UnpackScreenToTileBuffer
    Asm mov edi, Offset ScreenTilesBuffer         ' EDI = #ScreenTilesBuffer
    Asm mov ecx, 0x2a8 / 4                        ' ECX = 0x2a8 / 4
    Asm Xor eax, eax                              ' EAX = 0
    Asm cld 
    Asm repz stosd

    Asm movzx edi, Byte Ptr [ship_cur_screen] ' EDI = ship_cur_screen
    Asm mov edi, Dword Ptr [Screens+EDI*4]        ' EDI = Screens[EDI*4]
    Asm movzx ecx, Byte Ptr [edi]                 ' ECX = byte[EDI]
    Asm Inc edi                                   ' EDI++
    
                                                  ' loop(ecx)
    Asm loop_ecx_here:                            ' 
        Asm push ecx                              ' push(ECX)
    
        Asm movzx esi, Byte Ptr [edi+1]           ' ESI = byte[EDI+1]
        Asm imul esi, esi, 0x28                   ' ESI *= 0x28
        Asm movzx eax, Byte Ptr [edi]             ' EAX = byte[EDI]
        Asm add esi, eax                          ' ESI += EAX
        Asm add esi, Offset [ScreenTilesBuffer]   ' ESI += #ScreenTilesBuffer
        
        Asm movzx edx, Word Ptr [edi+2]           ' EDX = word[EDI+2]
        Asm mov edx, Dword Ptr [Patterns+edx*4]   ' EDX = Patterns[EDX*4]
        Asm mov cl, Byte Ptr [edx+1]              ' CL = byte[EDX+1]
        Asm mov ch, Byte Ptr [edx]                ' CH = byte[EDX]
        Asm lea edx, [edx+2]                      ' EDX += 2
        
        Asm loop_cl_start:                        ' for(; CL > 0; CL--) { 
         
            Asm push esi                          ' push(ESI)
            Asm push ecx                          ' push(ECX)
            
            Asm loop_ch_start:                    ' for(; CH > 0; CH--) {
            
                Asm mov al, Byte Ptr [edx]        ' AL = byte[EDX]
                Asm mov Byte Ptr [esi], al        ' byte[ESI] = al
                Asm Inc edx                       ' EDX++
                Asm Inc esi                       ' ESI++
                
            
            Asm dec ch
            Asm jnz loop_ch_start
            
            Asm pop ecx                           ' pop(ECX)
            Asm pop esi                           ' pop(ESI)
            Asm lea esi, [esi+0x28]               ' ESI += 0x28
        
        Asm dec cl
        Asm jnz loop_cl_start
        
    
        Asm pop ecx                               ' pop(ECX)
        Asm lea edi, [edi+4]                      ' EDI += 4
    Asm Loop loop_ecx_here 
End Sub 

Sub TileBufferToScreen
    For y As Integer = 0 To 16
        For x As Integer = 0 To 39
            PutTile x*8, y*8, @Tiles(ScreenTilesBuffer(y*&h28+x), 0)
        Next
    Next 
End Sub 

Sub ResetKeys
    asm
        mov edi, offset [Keys]
        mov ecx, 128/4
        xor eax, eax
        cld
        rep stosd
    end asm
End Sub

Function AnyKey As Integer
    For i As Integer = 0 To 127
        If Keys(i) = 1 Then Return 1
    Next
    Return 0
End Function

''==GAME====================================================================
#define SC_ESCAPE	&h01
#define SC_1		&h02
#define SC_2		&h03
#define SC_3		&h04
#define SC_4		&h05
#define SC_5		&h06
#define SC_6		&h07
#define SC_7		&h08
#define SC_8		&h09
#define SC_9		&h0A
#define SC_0		&h0B
#define SC_MINUS	&h0C
#define SC_EQUALS	&h0D
#define SC_BACKSPACE	&h0E
#define SC_TAB		&h0F
#define SC_Q		&h10
#define SC_W		&h11
#define SC_E		&h12
#define SC_R		&h13
#define SC_T		&h14
#define SC_Y		&h15
#define SC_U		&h16
#define SC_I		&h17
#define SC_O		&h18
#define SC_P		&h19
#define SC_LEFTBRACKET	&h1A
#define SC_RIGHTBRACKET	&h1B
#define SC_ENTER	&h1C
#define SC_CONTROL	&h1D
#define SC_A		&h1E
#define SC_S		&h1F
#define SC_D		&h20
#define SC_F		&h21
#define SC_G		&h22
#define SC_H		&h23
#define SC_J		&h24
#define SC_K		&h25
#define SC_L		&h26
#define SC_SEMICOLON	&h27
#define SC_QUOTE	&h28
#define SC_TILDE	&h29
#define SC_LSHIFT	&h2A
#define SC_BACKSLASH	&h2B
#define SC_Z		&h2C
#define SC_X		&h2D
#define SC_C		&h2E
#define SC_V		&h2F
#define SC_B		&h30
#define SC_N		&h31
#define SC_M		&h32
#define SC_COMMA	&h33
#define SC_PERIOD	&h34
#define SC_SLASH	&h35
#define SC_RSHIFT	&h36
#define SC_MULTIPLY	&h37
#define SC_ALT		&h38
#define SC_SPACE	&h39
#define SC_CAPSLOCK	&h3A
#define SC_F1		&h3B
#define SC_F2		&h3C
#define SC_F3		&h3D
#define SC_F4		&h3E
#define SC_F5		&h3F
#define SC_F6		&h40
#define SC_F7		&h41
#define SC_F8		&h42
#define SC_F9		&h43
#define SC_F10		&h44
#define SC_NUMLOCK	&h45
#define SC_SCROLLLOCK	&h46
#define SC_HOME		&h47
#define SC_UP		&h48
#define SC_PAGEUP	&h49
#define SC_MINUS2   &h4A
#define SC_LEFT		&h4B
#define SC_RIGHT	&h4D
#define SC_PLUS		&h4E
#define SC_END		&h4F
#define SC_DOWN		&h50
#define SC_PAGEDOWN	&h51
#define SC_INSERT	&h52
#define SC_DELETE	&h53
#define SC_F11		&h57
#define SC_F12		&h58

#define SC_LWIN		&h7D
#define SC_RWIN		&h7E
#define SC_MENU		&h7F

#define SH_DEAD 0
#define SH_ACTIVE 1

Type TSHIP Field=1
    x As Integer
    y As Integer
    i As Integer 
    state As UByte
    cur_frame As UByte
    
    anim_speed_cnt As UByte
    move_speed_cnt As UByte
    ai_update_cnt As UByte
    dx As Byte
    dy As Byte
    
    min_frame As UByte
    max_frame As UByte
    anim_speed As UByte
    move_speed As UByte
    ai_type As UByte            
    parent As Integer
End Type

#define SHIPS_NUMBER 13

Dim Shared As TSHIP Ships(0 To SHIPS_NUMBER-1)
Dim Shared As UByte player_attached = 0
Dim Shared As Integer base_cur_screen
Dim Shared As Integer base_level_start = 1
Dim Shared As Byte screen_procedure
Dim Shared As Integer screen_bridge = 0
Dim Shared As Integer game_level = 1 
Dim Shared As Integer ship_fuel = 5000
Dim Shared As Integer ship_lives = 10
Dim Shared As Integer ship_score = 0
Dim Shared As Integer laser_overload = 0


#define GM_EXIT -1
#define GM_TITLE 0
#define GM_GAME 1
#define GM_CUT 2
#define GM_GAMEOVER 3
#define GM_YOUWIN 4

Dim Shared As Integer game_mode = GM_TITLE

#define F_UP 0
#define F_RIGHT 1
#define F_DOWN 2
#define F_LEFT 3

Declare Sub BlowUpEnemy(i As Integer)    
Declare Function GetFreeEnemyIndex As Integer
Declare Sub DoEnemy(f As Integer)
Declare Sub InitNewScreen
Declare Sub RestartLevel

Function ChangeScreen(flag As Integer) As UByte
    Dim As UByte result = *(ScreenInfos(ship_cur_screen) + flag) 

    If result = 0 Then Return 0
    
    ' if base is blocking the way on the other screen
    If result = base_cur_screen Then
        If flag = F_LEFT Then
            If Ships(1).x >= 320 - 32 - 40 andalso Ships(0).y + 12 >= Ships(1).y Then Return 0
        End If
        If flag = F_RIGHT Then
            If Ships(1).x < 32 andalso Ships(0).y + 12 >= Ships(1).y Then Return 0
        End If
    End If
    
    If player_attached = 1 Then screen_bridge = 1 Else screen_bridge = 0
    
    ship_cur_screen = result
    Return 1    
End Function

Function IsHurt(x As Integer, y As Integer, index As Integer, index2 As Integer) As Integer
    Dim As Integer xs, ys, xs2, ys2
    Dim As TSHIP Ptr i = @Ships(index)
    Dim As TSHIP Ptr j = @Ships(index2)

    If index = 1 andalso ship_cur_screen <> base_cur_screen Then Return 0

    ' sprite dimensions    
    xs = **(Sprites(i->i) + i->cur_frame) * 4
    ys = *(*(Sprites(i->i) + i->cur_frame) + 1)
    
    ys += y: xs += x
    
    If j->state <> SH_DEAD Then
        ' ignore bridge and explosions
        If j->ai_type = 9 orelse j->ai_type = 8 Then Return 0

        xs2 = j->x + **(Sprites(j->i) + j->cur_frame) * 4
        ys2 = j->y + *(*(Sprites(j->i) + j->cur_frame) + 1)
        
        If x < j->x Then If xs > j->x Then GoTo _wdw2
        If x >= j->x Then
            If xs2 > x Then
            _wdw2:
                If y < j->y andalso ys > j->y Then Return 1
                If y >= j->y andalso ys2 > y Then Return 1
            End If
        End If
        
    End If
    
    Return 0
End Function

Function IsTouch(x As Integer, y As Integer, index as integer) As UByte
    Dim As Integer xs, ys, xs2, ys2
    Dim As TSHIP Ptr i = @Ships(index)

    ' sprite dimensions    
    xs = **(Sprites(i->i) + i->cur_frame) * 4
    ys = *(*(Sprites(i->i) + i->cur_frame) + 1)
      
    If x < 0 Then Return 1
    If y < 0 Then Return 1
    
    ys += y: xs += x
    
    If xs > 320 Then Return 1
    If ys > 136 Then Return 1

    For dy As Integer = y To ys - 1
        For dx As Integer = x To xs - 1
            If ScreenTilesBuffer((dy Shr 3) * 40 + (dx Shr 3)) > 1 Then Return 1
        Next        
    Next
     
    For f As Integer = 0 To SHIPS_NUMBER-1
        If @Ships(f) <> i Then ' don't compare with itself!
            If Ships(f).state <> SH_DEAD Then

                If index > 1 Then
                    ' ignore sparkles
                    If Ships(f).ai_type = 7 Then Continue For
                    If Ships(f).ai_type = 3 Then Continue For
                    ' homing missiles
                    If Ships(f).ai_type = 5 Then Continue For
                    ' and bridge
                    If Ships(f).ai_type = 9 Then Continue For
                    ' and bullets
                    If Ships(f).ai_type = 10 Then Continue For
                    
                    ' 
                    If Ships(index).ai_type = 3 orelse Ships(index).ai_type = 7 Then
                        If f > 1 Then Return 0
                    End If

                    If IsHurt(x, y, index, f) = 1 Then 
                        If f < 2 Then BlowUpEnemy(f)
                        Return 1
                    End If
                    
                    Continue For
                Else
                    If IsHurt(x, y, index, f) = 1 Then 
                        If f > 1 Then BlowUpEnemy(index)
                        Return 1
                    End If
                    Continue For
                End If

            End If
        End If
    Next

    Return 0
End Function


Function UpdateFuel As Integer
    Static As Integer fuel_cnt = 25
    
    If fuel_cnt = 0 Then
        If ship_fuel = 0 Then 
            game_mode = GM_GAMEOVER
            ResetKeys
            PutString(8*16, 8*10, @"NO FUERZA")            
            Return 1
        End If 
        ship_fuel -= 1
        fuel_cnt = 25
    Else
        fuel_cnt -= 1
    End If
    Return 0
End Function 

Sub DoShip
    
    Static As UByte fallflag = 1
    Static As Integer dy 
    'Static As ZString*16 aaa => "X: "
    'Static As ZString*16 bbb => "Y: "
    'Static As ZString*16 ccc => "S: "
    
    Static As TSHIP Ptr i
    
    i = @Ships(0)

    If i->ai_type = 8 Then DoEnemy(0): GoTo _end_of_sub
    'If Keys(SC_A) = 1 Then BlowUpEnemy(0): GoTo _end_of_sub

    ' check if ships are attached
    If Ships(1).state = SH_ACTIVE andalso Ships(1).x = i->x - 4 andalso Ships(1).y = i->y + 12 Then 
        ' if facing left or right
        If i->cur_frame = 0 orelse i->cur_frame = 6 Then player_attached = 1: screen_bridge = 1
    End If 

    ' go to the end of sub if attach mode ON
    If player_attached = 1 Then GoTo _end_of_sub    
    If UpdateFuel() = 1 Then Return
    
    ' delete sprite    
    PutBlank(i->x, i->y, *(Sprites(i->i) + i->cur_frame))    

    If Keys(SC_RIGHT) = 1 Then
        If i->cur_frame = 0 Then
            If IsTouch(i->x + 2, i->y, 0) = 0 Then 
                i->x += 2
            ElseIf i->x = 288 Then
                If ChangeScreen(F_RIGHT) = 1 Then i->x = 0: InitNewScreen
            End If
        Else
            If i->anim_speed_cnt = 0 Then
                i->cur_frame -= 1
                i->anim_speed_cnt = i->anim_speed
            Else
                i->anim_speed_cnt -= 1
            End If
        End If
    End If

    If Keys(SC_LEFT) = 1 Then
        If i->cur_frame = 6 Then
            If IsTouch(i->x - 2, i->y, 0) = 0 Then 
                i->x -= 2
            ElseIf i->x = 0 Then
                If ChangeScreen(F_LEFT) = 1 Then i->x = 288: InitNewScreen
            End If

        Else
            If i->anim_speed_cnt = 0 Then
                i->cur_frame += 1
                i->anim_speed_cnt = i->anim_speed               
            Else
                i->anim_speed_cnt -= 1               
            End If
        End If
    End If
    
    If Keys(SC_UP) = 1 Then
        If (i->y And 1) <> 0 Then dy = 1 Else dy = 2
        If IsTouch(i->x, i->y - dy, 0) = 0 Then 
            i->y -= dy
        ElseIf i->y = 0 Then
            If ChangeScreen(F_UP) = 1 Then i->y = 124: InitNewScreen
        End If
        
    Else
        If keys(SC_DOWN) = 1 Then
            If (i->y And 1) <> 0 Then dy = 1 Else dy = 2
            If IsTouch(i->x, i->y + dy, 0) = 0 Then 
                i->y += dy
            ElseIf i->y = 124 Then
                If ChangeScreen(F_DOWN) = 1 Then i->y = 0: InitNewScreen
            End If
        Else
            If fallflag = 0 Then
                If IsTouch(i->x, i->y + 1, 0) = 0 Then i->y += 1
                fallflag = 1
                If i->y = 124 Then
                    If ChangeScreen(F_DOWN) = 1 Then i->y = 0: InitNewScreen
                End If
            Else
                fallflag -= 1
            End If
        End If
    End If

    ' show itself   
    PutSprite(i->x, i->y, *(Sprites(i->i) + i->cur_frame))   

_end_of_sub:

    ' debug info
    'word2string(i->x, @aaa + 3)
    'PutString(8*8, 8*17, @aaa)
    'word2string(i->y, @bbb + 3)
    'PutString(8*15, 8*17, @bbb)
    'word2string(ship_cur_screen, @ccc + 3)
    'PutString(8*22, 8*17, @ccc)
    
    'word2string(Ships(1).x, @aaa + 3)
    'word2string(ScreenTilesBuffer(((Ships(1).y + 16) Shr 3) * 40 + ((Ships(1).x + 42) Shr 3)), @aaa + 3)
    
    'PutString(0, 36, @ddd)
   
        
End Sub


Sub ReEnableBase
    If base_cur_screen <> ship_cur_screen Then 
        Ships(1).state = SH_DEAD 
    Else 
        Ships(1).state = SH_ACTIVE
    End If
End Sub

Sub DoBase
    Static As TSHIP Ptr i, j
    'Static As Integer dy

    i = @Ships(0) ' ship
    j = @Ships(1) ' base
    
    If j->state = SH_DEAD Then
        If j->ai_type = 8 Then ' if exploded previously, reenable base at level start
            base_cur_screen = base_level_start       
            j->x = 160
            j->y = 104
            j->i = 1            
            j->min_frame = 0
            j->cur_frame = 0
            j->max_frame = 1
            j->anim_speed = 0
            j->anim_speed_cnt = 0
            j->ai_type = 0                    
        End If
        Return
    End If

    ' if exploding
    If j->ai_type = 8 Then
        DoEnemy(1)
        Return
    End If
          
    PutBlank(j->x, j->y, *(Sprites(j->i) + j->cur_frame))    

    ' do smth if attach mode ON
    If player_attached = 1 andalso i->ai_type <> 8 Then
        ' delete sprite    
        PutBlank(i->x, i->y, *(Sprites(i->i) + i->cur_frame))   
        
        If Keys(SC_RIGHT) = 1 Then
            If i->cur_frame = 0 Then
                
                'If j->anim_speed_cnt <= 0 Then
                '    j->anim_speed_cnt = j->anim_speed
                    j->cur_frame Xor= 1
                    
                    If IsTouch(i->x + 2, i->y, 0) + IsTouch(j->x + 2, j->y, 1) = 0 Then
                        if ScreenTilesBuffer(((j->y + 16) Shr 3) * 40 + ((j->x + 40) Shr 3)) <> 0 then _
                        i->x += 2: j->x += 2
                    ElseIf j->x = 280 Then
                        If ChangeScreen(F_RIGHT) = 1 Then i->x = 4: j->x = 0:  base_cur_screen = ship_cur_screen: InitNewScreen
                    End If
                'Else
                '    j->anim_speed_cnt -= 1
                'End If
                
            Else
                If i->anim_speed_cnt = 0 Then
                    i->cur_frame -= 1
                    i->anim_speed_cnt = i->anim_speed
                Else
                    i->anim_speed_cnt -= 1
                End If
            End If
        End If

        If Keys(SC_LEFT) = 1 Then
            If i->cur_frame = 6 Then
                'If j->anim_speed_cnt <= 0 Then   
                '    j->anim_speed_cnt = j->anim_speed
                    j->cur_frame Xor= 1                   
                    
                    If IsTouch(i->x - 2, i->y, 0) + IsTouch(j->x - 2, j->y, 1) = 0 Then
                        if ScreenTilesBuffer(((j->y + 16) Shr 3) * 40 + ((j->x - 2) Shr 3)) <> 0 then _
                        i->x -= 2: j->x -= 2                   
                    ElseIf j->x = 0 Then
                        If ChangeScreen(F_LEFT) = 1 Then i->x = 284: j->x = 280: base_cur_screen = ship_cur_screen: InitNewScreen
                    End If
                'Else
                '    j->anim_speed_cnt -= 1
                'End If                
    
            Else
                If i->anim_speed_cnt = 0 Then
                    i->cur_frame += 1
                    i->anim_speed_cnt = i->anim_speed               
                Else
                    i->anim_speed_cnt -= 1               
                End If
            End If
        End If


        If Keys(SC_UP) = 1 Then
            player_attached = 0
            i->y -= 2
            'If (i->y And 1) <> 0 Then dy = 1 Else dy = 2
            'If IsTouch(i->x, i->y - dy, i) = 0 Then 
            '    i->y -= dy
            'ElseIf i->y = 0 Then
            '    If ChangeScreen(F_UP) = 1 Then i->y = 124: InitNewScreen
            'End If            
        End If        
             
        
        ' show itself   
        PutSprite(i->x, i->y, *(Sprites(i->i) + i->cur_frame))         
    End If

    PutSprite(j->x, j->y, *(Sprites(j->i) + j->cur_frame))           
    
End Sub

Function RandomInt As Integer
    Static As Short randseed

    Asm
        mov dx, Word Ptr [randseed]
        mov bh, dl
        mov bl, 0xfd
        mov ah, dh
        sbb bx, dx
        sbb ah, 0
        sbb bx, dx
        sbb ah, 0
        mov dl, ah
        mov dh, 0
        sbb bx, dx
        jnb loc_0_13E6
        Inc bx
    loc_0_13E6:
        mov Word Ptr [randseed], bx
    End Asm 
    
    Return randseed And -1
End Function

Sub UpdateScore(update as integer)
    static as integer ship_score_cnt = 0

    if ship_score = 0 then ship_score_cnt = 0
    
    ship_score_cnt += update
    if ship_score_cnt > 15000 then ship_lives += 1: ship_score_cnt mod= 15000
    ship_score += update          
End Sub

Sub BlowUpEnemy(i As Integer)    

    ' if already exploding - exit
    If Ships(i).ai_type = 8 Then Return
    
    ' some corrections for homing missiles
    If Ships(i).i = 40 orelse Ships(i).i = 41 Then
        Return
        'PutBlank(Ships(i).x, Ships(i).y, *(Sprites(Ships(i).i) + Ships(i).cur_frame)) 
        'Ships(i).y -= 4
        'Ships(i).x += 4
    End If 
    
    ' if non-killable enemy - exit
    If Ships(i).i = 11 orelse Ships(i).i = 42 Then Return
    
    ' update score, exclude self-exploding bullets
    if Ships(i).ai_type <> 10 andalso i <> 0 andalso i <> 1 then _ 
    UpdateScore(Ships(i).ai_type * 100 * (game_level and 7) + (RandomInt() and 127))

    ' if blowing base - zero player_attached
    If i = 1 Then player_attached = 0
    
    ' reactivate parent cannon
    If Ships(i).i = 34 Then
        Ships(Ships(i).parent).dx = 0
    End If
    
    ' special procedures for breakable walls
    If Ships(i).i = 6 Then
        If Ships(i).cur_frame = 0 Then 
            Ships(i).x -= 8
            ScreenTilesBuffer((Ships(i).y Shr 3) * 40 + (Ships(i).x Shr 3)) = 0
            ScreenTilesBuffer(((Ships(i).y Shr 3) + 1) * 40 + (Ships(i).x Shr 3)) = 0
        Else
            ScreenTilesBuffer((Ships(i).y Shr 3) * 40 + (Ships(i).x Shr 3) + 1) = 0
            ScreenTilesBuffer(((Ships(i).y Shr 3) + 1) * 40 + (Ships(i).x Shr 3) + 1) = 0            
        End If
    End If
    
    Ships(i).ai_type = 8 ' explosion       
    If Ships(i).i = 6 Then 
        Ships(i).i = 7
    ElseIf Ships(i).i = 1 Then
        ' explosion's sprite is smaller than base's thus a little hack
        PutBlank(Ships(i).x, Ships(i).y, *(Sprites(Ships(i).i) + Ships(i).cur_frame))
        Ships(i).i = 23
        Ships(i).x += 4
        Ships(i).y += 4
    ElseIf Ships(i).i = 0 Then
        Ships(i).i = 23
    Else
        Ships(i).i = 2
    End If
    Ships(i).min_frame = 0
    Ships(i).max_frame = 2
    Ships(i).cur_frame = 0
    Ships(i).anim_speed = 6
    Ships(i).anim_speed_cnt = 6
    
End Sub

Function IsLaserHit(x As Integer, y As Integer) As Integer

    Dim As Integer xs2, ys2

    If x < 0 Then Return 1
    If x >= 320 Then Return 1
      
    ' if out of screen limits
    If ScreenTilesBuffer((y Shr 3) * 40 + (x Shr 3)) > 1 Then Return 1

    For f As Integer = 0 To SHIPS_NUMBER-1
        If Ships(f).state <> SH_DEAD Then
            
            ' exclude electric sparkles
            If Ships(f).ai_type = 7 Then Continue For
            If Ships(f).ai_type = 3 Then Continue For
            'If Ships(f).ai_type = 8 Then Continue For
            If Ships(f).ai_type = 9 Then Continue For
            If Ships(f).ai_type = 10 Then Continue For            
            
            xs2 = Ships(f).x + **(Sprites(Ships(f).i) + Ships(f).cur_frame) * 4
            ys2 = Ships(f).y + *(*(Sprites(Ships(f).i) + Ships(f).cur_frame) + 1)
            
            If x >= Ships(f).x Then
                If x < xs2 Then
                    If y >= Ships(f).y Then
                        If y < ys2 Then
                            ' blowup enemy if i <> 0
                            If f <> 0 Then BlowUpEnemy(f)
                            Return 1
                        End If
                    End If
                End If
            End If           
        End If
    Next


    Return 0    
End Function


function UpdateLaser(i as integer) as integer
    'static as integer laser_cnt = 0

    laser_overload += i    
    if laser_overload > 32*8-1 then laser_overload = 0: return 1
    if laser_overload < 0 then laser_overload = 0     
    
    return 0
end function

Dim Shared As Integer laser_dir = 0   

Sub DoLaser
    Static As Integer x_start, lx, ly, laser_phase = 0, x_end, dx 
    
    If Keys(SC_SPACE) = 1 orelse Keys(SC_ENTER) = 1 Then
        If UpdateLaser(1) = 1 Then BlowUpEnemy(0): ResetKeys: Return
    Else
        UpdateLaser(-1)
    End If
      
    ' if zero - no shooting, 1 - shooting right, -1 - shooting left    
    If laser_dir = 0 Then
        If Keys(SC_SPACE) = 1 OrElse Keys(SC_ENTER) = 1 Then
            'if ship facing right
            If Ships(0).cur_frame = 0 Then            
                lx = Ships(0).x + 32
                x_start = lx
                ly = Ships(0).y + 6
                laser_dir = 1
                laser_phase = 0
                GoTo __woo
            ' if facing left
            ElseIf Ships(0).cur_frame = 6 Then
                lx = Ships(0).x - 1
                x_start = lx
                ly = Ships(0).y + 6
                laser_dir = -1
                laser_phase = 0
                GoTo __woo
            End If
        End If
              
    Else
        __woo:
        ' animate laser
        ' shooting right
        If laser_dir = 1 Then
            If laser_phase = 0 Then
                For dx = lx To lx + 11 
                    If IsLaserHit(dx, ly) = 1 Then
                        x_end = dx
                        lx = x_start
                        laser_phase = 1                              
                        Return
                    End If 
                    Poke Byte, ly * 320 + dx + @ScreenBuffer(0), 7
                    
                Next
            Else
                For dx = lx To lx + 11 
                    If dx = x_end Then laser_dir = 0: Return
                    If IsLaserHit(dx, ly) = 0 Then Poke Byte, ly * 320 + dx + @ScreenBuffer(0), 0
                Next
            End If
            lx += 12
        ' shooting left
        ElseIf laser_dir = -1 Then
            If laser_phase = 0 Then
                For dx = lx To lx - 11 Step -1 
                    If IsLaserHit(dx, ly) = 1 Then
                        x_end = dx
                        lx = x_start
                        laser_phase = 1                              
                        Return                       
                    End If 
                    Poke Byte, ly * 320 + dx + @ScreenBuffer(0), 7
                Next
            Else
                For dx = lx To lx - 11 Step -1 
                    If dx = x_end Then laser_dir = 0: Return
                    If IsLaserHit(dx, ly) = 0 Then Poke Byte, ly * 320 + dx + @ScreenBuffer(0), 0
                Next
                
            End If
            lx -= 12
            
        End If        
    End If
End Sub

' update animation counters
' returns 1 if reached the end of animation cycle
Function UpdateAnimation(f As Integer) As Integer
    Static As TSHIP Ptr i
    
    i = @Ships(f)

    ' do animation counters
    If i->anim_speed_cnt = 0 Then
        i->anim_speed_cnt = i->anim_speed
        i->cur_frame += 1
        If i->cur_frame > i->max_frame Then 
            i->cur_frame = i->min_frame
            Return 1
        End If  
    Else
        i->anim_speed_cnt -= 1
    End If
    
    Return 0
End Function

' returns 1 if reached the end of move-wait cycle
Function UpdateMoveSpeed(f As Integer) As Integer
    Static As TSHIP Ptr i
    
    i = @Ships(f)
    If i->move_speed_cnt = 0 Then 
        i->move_speed_cnt = i->move_speed 
        Return 1
    Else
        i->move_speed_cnt -= 1
    End If
    
    Return 0
End Function

Sub DoEnemy(f As Integer)
    Static As TSHIP Ptr i
    
    i = @Ships(f)
    
    If i->state = SH_DEAD Then Return

    PutBlank(i->x, i->y, *(Sprites(i->i) + i->cur_frame))
    
    ' do different ai types
    Select Case As Const i->ai_type
        
        Case 0 ' breakable wall or non-moving enemy
            UpdateAnimation(f)
        Case 1 ' randomly moving enemy
            UpdateAnimation(f)
            If UpdateMoveSpeed(f) = 1 Then
                If i->ai_update_cnt = 0 Then
                    i->dx = RandomInt() And 3
                    If i->dx >= 2 Then i->dx = -1
                    
                    i->dy = RandomInt() And 3
                    If i->dy >= 2 Then i->dy = -1
                    
                    i->ai_update_cnt = RandomInt() And &h1f
                    If i->ai_update_cnt < 15 Then i->ai_update_cnt = 15
                Else
                    i->ai_update_cnt -= 1
                End If
            _optimize1:    
                If IsTouch(i->x + i->dx, i->y, f) = 0 Then i->x += i->dx Else i->ai_update_cnt = 0
                If IsTouch(i->x, i->y + i->dy, f) = 0 Then i->y += i->dy Else i->ai_update_cnt = 0
                
            End If

        Case 2 ' kamikadze
            UpdateAnimation(f)
            If UpdateMoveSpeed(f) = 1 Then
                If i->ai_update_cnt = 0 Then
                    If i->x > Ships(0).x Then
                        i->dx = -1
                    ElseIf i->x < Ships(0).x Then
                        i->dx = 1
                    Else                
                        i->dx = 0
                    End If
    
                    If i->y > Ships(0).y Then
                        i->dy = -1
                    ElseIf i->y < Ships(0).y Then
                        i->dy = 1
                    Else
                        i->dy = 0
                    End If
                    
                    i->ai_update_cnt = 15

                Else
                    i->ai_update_cnt -= 1
                End If

                GoTo _optimize1
                'If IsTouch(i->x + i->dx, i->y, f) = 0 Then i->x += i->dx Else i->ai_update_cnt = 0
                'If IsTouch(i->x, i->y + i->dy, f) = 0 Then i->y += i->dy Else i->ai_update_cnt = 0
                
            End If

        Case 3 ' electric sparkle going up-down
            UpdateAnimation(f)
            If UpdateMoveSpeed(f) = 1 Then 
                If i->dy = 0 Then i->dy = 1
                If IsTouch(i->x, i->y + i->dy, f) = 0 Then i->y += i->dy Else i->dy = -i->dy
            End If
                 
        Case 4 ' ceiling cannon spawning kamikazes
            ' if object is spawned - do nothig
            If i->dx = 1 Then GoTo _the_end
            If UpdateAnimation(f) = 1 Then
                i->dx = 1
                
                ' spawn a new enemy
                Scope
                    Dim As TSHIP Ptr j
                    
                    j = @Ships(0) + GetFreeEnemyIndex()
                    
                    j->state = SH_ACTIVE
                    j->i = 34
                    j->x = i->x 
                    j->y = i->y + 16
                    j->anim_speed = 4
                    j->anim_speed_cnt = j->anim_speed
                    j->move_speed = 0
                    j->move_speed_cnt = j->move_speed 
                    j->min_frame = 0
                    j->cur_frame = j->min_frame
                    j->max_frame = 3
                    j->ai_type = 2
                    j->parent = f
                    
                End Scope
            End If
            
        Case 5 ' homing missile
            UpdateAnimation(f)
            'If UpdateMoveSpeed(f) = 1 Then
                If i->x > 0 Then
                    i->x -= 2
                    IsTouch(i->x, i->y, f)
                    If i->x < Ships(0).x Then GoTo _the_end
                    If i->y > Ships(0).y Then i->y -= 1
                    If i->y < Ships(0).y andalso i->y < 63 Then If (RandomInt() and 1) = 1 then i->y += 1 
                Else
                    i->x = 296
                    i->y = RandomInt() And 63
                    If i->i = 40 Then i->i = 41 Else i->i = 40 
                End If
            'End If
        Case 6 ' cannon
            If i->x - 40 > Ships(0).x Then
                i->cur_frame = 0
            ElseIf i->x + 40 < Ships(0).x Then
                i->cur_frame = 2
            Else
                i->cur_frame = 1
            End If
            
            If (RandomInt() And 255) = 255 Then
                Dim As TSHIP Ptr j
                    
                j = @Ships(0) + GetFreeEnemyIndex()
                
                If j->state = SH_DEAD Then
                    j->state = SH_ACTIVE
                    j->i = 43
                    If i->cur_frame = 0 Then j->x = i->x - 4: j->y = i->y + 4: j->dx = -1: j->dy = -1
                    If i->cur_frame = 1 Then j->x = i->x + 6: j->y = i->y - 4: j->dx = 0: j->dy = -1
                    If i->cur_frame = 2 Then j->x = i->x + 16: j->y = i->y + 4: j->dx = 1: j->dy = -1
                    j->anim_speed = 4
                    j->anim_speed_cnt = j->anim_speed
                    j->move_speed = 0
                    j->move_speed_cnt = j->move_speed 
                    j->min_frame = 0
                    j->cur_frame = j->min_frame
                    j->max_frame = 0
                    j->ai_type = 10
                    j->parent = f                    
                End If
            End If
        Case 7 ' electric sparkle going left-right
            UpdateAnimation(f)
            If UpdateMoveSpeed(f) = 1 Then
                If i->dx = 0 Then i->dx = 1
                If IsTouch(i->x + i->dx, i->y, f) = 0 Then i->x += i->dx Else i->dx = -i->dx
            End If
            
        Case 8 ' explosion, do one animation cycle and deactivate enemy entry
            If UpdateAnimation(f) = 1 Then 
                i->state = SH_DEAD
                If f = 0 Then RestartLevel
                Return
            End If
            
        Case 9 ' bridge, appear if bonded ship, disappear otherwise
            If screen_bridge = 0 Then Return ' FIXME - flickering because of PutBlank
            
            ' seal the floor
            ' FIXME - do it once!
            For f As Integer = 0 To 4                
                ScreenTilesBuffer((i->y Shr 3) * 40 + (i->x Shr 3) + f) = 245
            Next
        Case 10 ' bullet    
            
            ' random exploding
            If i->y + 16 < Ships(i->parent).y andalso (RandomInt And 63) = 1 Then BlowUpEnemy(f): GoTo _the_end
            
            i->x += i->dx
            If i->x < 0 orelse i->x > 320 Then BlowUpEnemy(f): GoTo _the_end
            
            i->y += i->dy
            If i->y < 0 Then BlowUpEnemy(f)
    End Select
    
_the_end:
    PutSprite(i->x, i->y, *(Sprites(i->i) + i->cur_frame))    
End Sub

Sub InitShip

    Asm
        mov edi, Offset Ships
        mov ecx, SizeOf(TSHIP)*SHIPS_NUMBER
        Xor eax, eax
        rep stosb
    End Asm
    
    ' flying ship data
    Ships(0).state = SH_ACTIVE
    Ships(0).x = 152
    Ships(0).y = 68
    Ships(0).i = 0
    Ships(0).min_frame = 0
    Ships(0).cur_frame = IIf((game_level And 1) = 0, 6, 0) 
    Ships(0).max_frame = 6
    Ships(0).anim_speed = 1
    Ships(0).anim_speed_cnt = 1
    
    ' base data
    Ships(1).state = SH_ACTIVE
    Ships(1).x = 148
    Ships(1).y = 104
    Ships(1).i = 1
    Ships(1).min_frame = 0
    Ships(1).cur_frame = 0
    Ships(1).max_frame = 1
    Ships(1).anim_speed = 0 
    Ships(1).anim_speed_cnt = 0
    
End Sub

Function GetFreeEnemyIndex As Integer
    For i As Integer = 2 To SHIPS_NUMBER-1
        If Ships(i).state = SH_DEAD Then Return i ' and ai_type should be zero!
    Next
    
    Return 12
End Function

Sub InitEnemies
    Asm
        mov edi, Offset Ships+SizeOf(TSHIP)*2
        mov ecx, SizeOf(TSHIP)*(SHIPS_NUMBER-2)
        Xor eax, eax
        rep stosb
    End Asm
    
    Dim p As UByte Ptr
    Dim en As TSHIP Ptr
    
    p = ScreenInfos(ship_cur_screen) + 5
    
    For i As Integer = *(p - 1) To 1 Step -1
        If *p <> 128 Then ' <> 128 '64 is the bridge
            en = @Ships(0) + GetFreeEnemyIndex()
            en->state = SH_ACTIVE
            en->i = *(p + 1)
            en->x = *(p + 2) Shl 2 
            en->y = *(p + 3)
            en->anim_speed = *(p + 4) * 2
            en->anim_speed_cnt = en->anim_speed
            en->min_frame = *(p + 5)
            en->cur_frame = en->min_frame
            en->max_frame = *(p + 6)
            en->ai_type = *(p + 7)
            If *p = 64 Then en->ai_type = 9 ' hack for bridge 
            en->move_speed = 1 ' standard
            en->move_speed_cnt = en->move_speed 
        End If
        p += 8
    Next
    
    screen_procedure = *p
    
End Sub 


Sub InitNewScreen
    UnpackScreenToTileBuffer
    TileBufferToScreen
    InitEnemies

    ReEnableBase        
    laser_dir = 0 
End Sub

Sub InitNewGame    

    ship_fuel = 5000
    ship_lives = 10
    ship_score = 0
    
    ship_cur_screen = 1
    base_cur_screen = 1
    base_level_start = 1
    game_level = 1
    
    player_attached = 0
        
    InitShip    
    InitNewScreen

    For f As Integer = 0 To 6
        PutStream 0, statusbars(f, 1) * 8 , @statusbars(f, 2)    
    Next     
End Sub

Function UpdateLives As Integer
    ship_lives -= 1
    If ship_lives = 0 Then 
        game_mode = GM_GAMEOVER
        ResetKeys
        PutString(8*16, 8*10, @"HAS PERDIDO")
        Return 1
    End If
    Return 0
End Function

Sub RestartLevel

    if UpdateLives() = 1 then return
    
    
    player_attached = 0
    ship_cur_screen = base_level_start
    base_cur_screen = base_level_start

    InitShip    
    InitNewScreen
    
End Sub

Sub DoElevator
    Static As Integer el_phase = 0
        
    If el_phase = 0 Then
        If Ships(0).y = 0 Then 
            el_phase = 1
            Ships(0).y = 108
            Ships(1).y = 120
            
            ChangeScreen(F_UP)
            base_cur_screen = ship_cur_screen
            InitNewScreen
              
            GoTo _here
        End If
        
    Else
        If Ships(1).y = 104 Then 
            el_phase = 0
            game_mode = GM_GAME
            
            ' seal the floor!
            For i As Integer = 0 To 5                
                ScreenTilesBuffer(((Ships(1).y + 16) Shr 3) * 40 + ((Ships(1).x - 4) Shr 3) + i) = 245
            Next
            If ship_cur_screen <> 69 Then game_level += 1': rad_play_tune(@rad_tune2)
            base_level_start = ship_cur_screen
            Return
        End If        
    End If

    Ships(0).y -= 1
    Ships(1).y -= 1
    
_here:    
    PutSprite(Ships(0).x, Ships(0).y, *(Sprites(Ships(0).i) + Ships(0).cur_frame))
    PutSprite(Ships(1).x, Ships(1).y, *(Sprites(Ships(1).i) + Ships(1).cur_frame))
    
    For i As Integer = 0 To 5
        PutTile(Ships(1).x - 4 + i * 8, Ships(1).y + 16, @Tiles(245, 0))
    Next
      
End Sub

Sub Int2ZString(digit As Integer, num_of_digits As Integer, buffer As ZString Ptr)

    Static As Integer _smth(0 To 7) = {10000000, 1000000, 100000, 10000, 1000, 100, 10, 1}

    If num_of_digits > 8 Then num_of_digits = 8
       
    asm mov ecx, [num_of_digits]
    asm mov eax, 0x30
    asm mov edi, [buffer]
    asm cld
    asm rep stosb
    
    For i As Integer = 8-num_of_digits To 7
        Asm mov ebx, [i]
        Asm mov eax, [digit]
        Asm Xor edx, edx
        Asm mov ecx, [_smth+ebx*4]
        Asm div ecx
        Asm mov [digit], edx
        Asm Or al, 0x30
        Asm Sub ebx, 8
        Asm add ebx, [num_of_digits]
        Asm add ebx, [buffer]
        Asm mov Byte Ptr [ebx], al
        Asm Xor ah,ah
        Asm mov Byte Ptr [ebx + 1], ah 
    Next
    
End Sub

Sub DoStatus
    Static As ZString*16 string_buffer
    
    ' level
    Int2ZString(game_level, 2, @string_buffer)
    PutString 8*16, 8*20, @string_buffer
    
    ' fuel
    Int2ZString(ship_fuel, 4, @string_buffer)
    PutString 8*14, 8*21, @string_buffer
    
    ' score
    Int2ZString(ship_score, 8, @string_buffer)
    PutString 8*10, 8*22, @string_buffer

    ' laser
    for i as integer = 0 to 31
        dim as ubyte c = iif(i < (laser_overload shr 3), 5, 0)
        asm
            mov edx, [i]
            mov cl, [c]
            mov [ScreenBuffer+edx+192+162*320], cl
            mov [ScreenBuffer+edx+192+162*320+320], cl
            mov [ScreenBuffer+edx+192+162*320+320*2], cl
        end asm
    next

    ' laser     
    'Int2ZString(laser_overload shr 3, 2, @string_buffer)
    'PutString 8*28, 8*20, @string_buffer
   
    ' lives
    Int2ZString(ship_lives, 2, @string_buffer)
    PutString 8*28, 8*21, @string_buffer
    
    ' score record
    PutString 8*22, 8*22, @"88888888"


    
End Sub

Sub DoTitle
    Static As Integer _flag = 0
    Static As Integer _toggle = 1
    
    If _flag = 0 Then
        rad_play(@rad_tune1)
        Asm
            mov edi, Offset ScreenBuffer
            mov ecx, 320*200/4
            Xor eax, eax
            cld
            rep stosd
        End Asm
        ship_cur_screen = 0
        _flag = 1
        InitNewScreen
        PutSprite 50*4, 108, *(Sprites(45) + 0)
        PutString 76, 88, @"ESPACIO PARA COMENZAR"
        PutString 76, 88 - 32, @"S TO TOGGLE SCANLINES"
        PutSprite 96, 142, @Logo
    End If
    If Keys(SC_ESCAPE) = 1 Then game_mode = GM_EXIT: Return
    If Keys(SC_SPACE) = 1 Then game_mode = GM_GAME: _flag = 0: rad_stop: ResetKeys: InitNewGame
    If Keys(SC_S) = 1 Then Keys(SC_S) = 0: _toggle xor= 1: LM_GFX_SetScale(_toggle + 1)
End Sub

Sub DoWinScreen
    Static As Integer flag = 0
    Static As Integer i = 0
    Static as ZString*410 win_string => _
    "                                        " + _
    "ATENCION    ATENCION     TRANSMISION A LA NAVE EXPLORER           " + _
    "HAS CUMPLIDO TU ULTIMA MISION Y DEBES RETORNAR AL PLANETA NOVA DE LA GALAXIA TRAION" + _
    "                                        " + _
    "TU LUCHA NO HA SIDO EN VANO PUES LA LEJANA COLONIA DEL IMPERIO LLAMADA TIERRA HA SIDO " + _
    "LIBERADA DE LOS INVASORES Y PUEDE SER HABITADA DE NUEVO               REPITO  MENSAJE"
    
    If flag = 0 Then
        asm mov edi, offset ScreenBuffer + 144*320
        asm mov ecx, 320*56/4
        asm xor eax, eax
        asm cld
        asm rep stosd
        flag = 1
        i = 0
    End If
    
    PutString 0 - i mod 8, 20*8, @win_string + i\8
    
    If i\8 >= SizeOf(win_string) Then i = 0 Else i += 1
    
    If AnyKey = 1 Then game_mode = GM_TITLE: flag = 0: ResetKeys
End Sub

Sub DoGame

    Select Case As Const game_mode
        Case GM_TITLE
            ' do title here
            DoTitle             
        Case GM_GAME
            ' check for screen procedures
            If player_attached = 1 Then
                If screen_procedure = 1 andalso Ships(1).x >= 260 Then game_mode = GM_CUT: Return
                If screen_procedure = 2 andalso Ships(1).x <= 20 Then game_mode = GM_CUT: Return
            End If             
            
            ' win the game:
            If screen_procedure = 3 andalso base_cur_screen >= 70 Then game_mode = GM_YOUWIN: ResetKeys: Return 
            
            ' do enemies
            For i As Integer = 2 To SHIPS_NUMBER-1
                if Ships(0).ai_type <> 8 then DoEnemy(i)
            Next
            
            DoShip
            DoBase                        
            DoLaser
            DoStatus

            If Keys(SC_ESCAPE) = 1 Then game_mode = GM_TITLE: ResetKeys
                       
            'PutSprite 0, 140, *(sprites(11) + 0)
        Case GM_CUT
            DoElevator            
        Case GM_GAMEOVER            
            If AnyKey = 1 then InitNewGame: ResetKeys: game_mode = GM_TITLE
        Case GM_YOUWIN
            DoWinScreen
    End Select 
    
End Sub

''==MAIN====================================================================
Static As Integer next_game_tick = 0
Static As Integer sleep_time = 0, frames = 0, frame_end = 0, frame_start = 0
'Static As Integer fps = 60

LM_Init
rad_init

next_game_tick = LM_Timer()
    
While 0=0

    If frames = 0 Then frame_start = next_game_tick

    LM_PollEvents

    DoGame

    PutString 8*0, 8*17, @infostring

    LM_GFX_Flip(@ScreenBuffer(0))
     
    next_game_tick += CInt(1000/60)
    
    frames += 1
    frame_end = LM_Timer

    If frame_end - frame_start >= 1000 Then
        word2string(frames, @infostring + 5)
        frames = 0
    End If
    
    sleep_time = next_game_tick - frame_end
    If(sleep_time > 0) Then
	    LM_Sleep(sleep_time)
	Else
	    ' slow computer, do as fast as we can
            LM_Sleep(2)
            next_game_tick = LM_Timer
            'LM_GFX_SetScale(1) ' if slow computer, switch off scaling
    End If

    If game_mode = GM_EXIT Then Exit While
Wend
__end:
rad_deinit
LM_Deinit 








