'
' This is a very simple .rad adlib files player which
' uses ym3812 (OPL2) emulator from MAME and WINMM.DLL
' for sound output.
' Use as you wish for your own purposes.
'


#include once "fmopl.bi"
#include once "windows.bi"
#include once "win\mmsystem.bi"
#include once "crt.bi"

const freqhz = 44100
dim shared as integer framesmpl = freqhz \ 50
const buffsmpl = 2048

dim shared as integer ym = 0
dim shared as short buf(0 to buffsmpl-1) 'mono

'' -------------
#ifndef WAVE_MAPPER
#define WAVE_MAPPER (-1)
#endif

#define	REPLAY_RATE	         44100
#define	REPLAY_DEPTH         16
#define	REPLAY_SAMPLELEN     (REPLAY_DEPTH\8)
#define	REPLAY_NBSOUNDBUFFER 4

type USER_CALLBACK as sub cdecl (byval as any ptr, byval as integer ptr, byval as integer)


dim shared as integer m_bServerRunning
dim shared as integer m_bufferSize
dim shared as integer m_currentBuffer
dim shared as HWAVEOUT m_hWaveOut  
dim shared as WAVEHDR m_waveHeader(0 to REPLAY_NBSOUNDBUFFER-1)
dim shared as integer ptr m_pSoundBuffer(0 to REPLAY_NBSOUNDBUFFER-1)
dim shared as USER_CALLBACK m_pUserCallback
'' -------------

declare sub rad_play(byval raw_tune as ubyte ptr)
declare sub rad_stop 
'' MMSYSTEM STUFF =======================================================================
sub fillNextBuffer

    ' strictly needed to avoid deadlocks!
    ' MSDN says never ever use wave*** or system functions inside a callback but who cares...
    ' in fact only waveOutReset can cause a deadlock when a callback calls other wave*** functions
    if m_pUserCallback = 0 then return

    '' check if the buffer is already prepared (should not!)
    if m_waveHeader(m_currentBuffer).dwFlags and WHDR_PREPARED <> 0 then _
        waveOutUnprepareHeader(m_hWaveOut, @m_waveHeader(m_currentBuffer), sizeof(WAVEHDR))

    '' Call the user function to fill the buffer with anything you want! :-)
    if m_pUserCallback <> 0 then   
        m_pUserCallback(0, m_pSoundBuffer(m_currentBuffer), m_bufferSize)
    
        '' Prepare the buffer to be sent to the WaveOut API
        m_waveHeader(m_currentBuffer).lpData = cast(ubyte ptr, m_pSoundBuffer(m_currentBuffer))
        m_waveHeader(m_currentBuffer).dwBufferLength = m_bufferSize
        waveOutPrepareHeader(m_hWaveOut, @m_waveHeader(m_currentBuffer), sizeof(WAVEHDR))
    
        '' Send the buffer the the WaveOut queue
        waveOutWrite(m_hWaveOut, @m_waveHeader(m_currentBuffer), sizeof(WAVEHDR))
    
        m_currentBuffer += 1
        if m_currentBuffer >= REPLAY_NBSOUNDBUFFER then m_currentBuffer = 0
    end if
end sub

sub waveOutProc(hwo as HWAVEOUT, uMsg as UINT, dwInstance as DWORD, dwParam1 as DWORD, dwParam2 as DWORD)
    if uMSG = WOM_DONE then
        fillNextBuffer()
    end if
end sub

function WINMM_open(pUserCallback as USER_CALLBACK, totalBufferedSoundLen as integer) as integer

    dim as WAVEFORMATEX wfx
    dim as MMRESULT errCode


    m_pUserCallback = NULL
    m_bServerRunning = FALSE
    m_currentBuffer = 0
    
    m_pUserCallback = pUserCallback
    m_bufferSize = 2048*2 '*4 if stereo     
    		
    wfx.wFormatTag = WAVE_FORMAT_PCM
    wfx.nChannels = 1
    wfx.nSamplesPerSec = REPLAY_RATE
    wfx.nAvgBytesPerSec = REPLAY_RATE * REPLAY_SAMPLELEN 
    wfx.nBlockAlign = REPLAY_SAMPLELEN
    wfx.wBitsPerSample = REPLAY_DEPTH
    wfx.cbSize = 0
	
	errCode = waveOutOpen(@m_hWaveOut, WAVE_MAPPER, @wfx, cast(DWORD, @waveOutProc), 0, CALLBACK_FUNCTION)

    if errCode <> 0 then return FALSE
    
    '' Alloc the sample buffers.
    for i as integer = 0 to REPLAY_NBSOUNDBUFFER-1
        m_pSoundBuffer(i) = malloc(m_bufferSize)
        memset(@m_waveHeader(i), 0, sizeof(WAVEHDR))
        memset(m_pSoundBuffer(i), 0, m_bufferSize)
    next

    '' Fill all the sound buffers
    m_currentBuffer = 0
    for i as integer = 0 to REPLAY_NBSOUNDBUFFER-1
        fillNextBuffer()
    next

    m_bServerRunning = TRUE

    return TRUE	
end function
sub WINMM_close
    if m_bServerRunning = TRUE then
        
        ' this makes a callback stop updating the buffers
        m_pUserCallback = NULL

        ' just to be sure buffers done playing
        sleep_ 20

        ' it may hang here
        if waveOutReset(m_hWaveOut) <> 0 then printf !"waveOutReset error!\n" 
        for i as integer = 0 to REPLAY_NBSOUNDBUFFER-1
            if (m_waveHeader(m_currentBuffer).dwFlags and WHDR_PREPARED) <> 0 then _
                waveOutUnprepareHeader(m_hWaveOut,@m_waveHeader(i), sizeof(WAVEHDR))
                
            free(m_pSoundBuffer(i))
        next
        
        if waveOutClose(m_hWaveOut) <> 0 then  printf !"waveOutClose error!\n" 
        m_bServerRunning = FALSE
    end if
end sub

sub WINMM_reset
    '' Clear the sample buffers to make silence
    for i as integer = 0 to REPLAY_NBSOUNDBUFFER-1
        memset(m_pSoundBuffer(i), 0, m_bufferSize)
    next
    'm_currentBuffer = 0
    for i as integer = 0 to REPLAY_NBSOUNDBUFFER-1
        fillNextBuffer()
    next
end sub


'' SUBS/FUNCTIONS =======================================================================

type rad_A0B0 field=1
    union
        type
            lo_byte as ubyte
            hi_byte as ubyte
        end type
        type
            freq : 10 as ushort
            octave : 3 as ushort
            noteon : 1 as ushort
        end type
    end union
end type

type rad_player_data
    update as sub
    active as byte
    pdata as ubyte ptr
    tmr_speed as ushort
    size as integer
    pattern_jmp_f as ubyte

    Speed as byte
    SpeedCnt as byte 
    OrderSize as byte
    pOrderList as ubyte ptr
    Orderpos as byte   
    
    pPatternList as ubyte ptr 
    pPatternPos as ubyte ptr
    CurrentLine as ubyte
    
    pInstr(0 to 30) as ubyte ptr
    Old43(0 to 8) as ubyte
    OldA0B0(0 to 8) as rad_A0B0
    
    ToneSlideSpeed(0 to 8) as ubyte
    ToneSlideFreq(0 to 8) as uinteger
    
    ToneSlide(0 to 8) as byte
    PortSlide(0 to 8) as byte
    VolSlide(0 to 8) as byte
    
end type

dim shared as integer rad_NoteFreq(0 to 11) = {&h16b,&h181,&h198,&h1b0,&h1ca,&h1e5,&h202,&h220,&h241,&h263,&h287, &h2ae}
dim shared as ubyte rad_ChannelOffs(0 to 8) = {&h20,&h21,&h22,&h28,&h29,&h2a,&h30,&h31,&h32}
dim shared as rad_player_data rad

'sub rad_setspeed(value as uinteger)
'    rad.tmr_speed = value
'    if rad.tmr_speed = 0 then rad.tmr_speed = &hffff 
'        
'    framesmpl = freqhz \ (1193180 \ rad.tmr_speed)
'end sub 

sub rad_adlib_write(adl_reg as byte, adl_data as ubyte)
    'AdlibWrite(adl_reg, adl_data)

    OPL2Write(ym, 0, adl_reg)
    OPL2Write(ym, 1, adl_data)
    
    'ymf262write(ym, 0, adl_reg)
    'ymf262write(ym, 1, adl_data)
end sub

sub rad_load_instrument(channel as integer, inst_number as integer)
    dim as integer r = rad_ChannelOffs(channel) 
    dim as ubyte ptr p = rad.pInstr(inst_number) 
    
    if p <> 0 then
        rad.Old43(channel) = *(p + 2)
        for i as integer = 0 to 3
            rad_adlib_write(r, *(p + 1))
            rad_adlib_write(r + 3, *p)
            p += 2
            r += &h20
        next
        rad_adlib_write(r + &h40, *(p + 2))
        rad_adlib_write(r + &h43, *(p + 1))
        rad_adlib_write(channel + &hc0, *p)
    end if    
end sub

sub rad_set_volume(channel as integer, new_volume as integer)
    if new_volume > 63 then new_volume = 63
    rad.Old43(channel) = (rad.Old43(channel) and &hc0) + (new_volume xor &h3f)
    rad_adlib_write(rad_ChannelOffs(channel) + &h23, rad.Old43(channel)) 
end sub

function rad_get_freq(i as integer) as uinteger
    return (rad.OldA0B0(i).freq - &h157) + rad.OldA0B0(i).octave * (&h2ae - &h157)
end function

sub rad_set_freq(i as integer, new_freq as uinteger)
          
    rad.OldA0B0(i).freq = new_freq mod (&h2ae - &h157) + &h157
    rad.OldA0B0(i).octave = new_freq \ (&h2ae - &h157)
    rad_adlib_write(&hb0 + i, rad.OldA0B0(i).hi_byte)
    rad_adlib_write(&ha0 + i, rad.OldA0B0(i).lo_byte)

    
end sub

sub rad_update_notes
    ' process portamentos
    for i as integer = 0 to 8
        if rad.PortSlide(i) <> 0 then rad_set_freq(i, rad_get_freq(i) + rad.PortSlide(i))
    next
    
    ' process volume slides
    for i as integer = 0 to 8
        dim as byte v
        if rad.VolSlide(i) > 0 then
            v = ((rad.old43(i) and &h3f) xor &h3f) - rad.VolSlide(i)
            if v >= 64 then v = 63
            rad_set_volume(i, v) 
        else
            v = ((rad.old43(i) and &h3f) xor &h3f) - rad.VolSlide(i)
            if v < 0 then v = 0
            rad_set_volume(i, v)
        endif
    next
    
    ' process tone slides
    for i as integer = 0 to 8
        if rad.ToneSlide(i) <> 0 then            
            if rad_get_freq(i) > rad.ToneSlideFreq(i) then
                if rad_get_freq(i) - rad.ToneSlideSpeed(i) < rad.ToneSlideFreq(i) then goto _jmp_0
                rad_set_freq(i, rad_get_freq(i) - rad.ToneSlideSpeed(i))
            elseif rad_get_freq(i) < rad.ToneSlideFreq(i) then
                if rad_get_freq(i) + rad.ToneSlideSpeed(i) > rad.ToneSlideFreq(i) then goto _jmp_0
                rad_set_freq(i, rad_get_freq(i) + rad.ToneSlideSpeed(i))
            else
            _jmp_0:
                rad.ToneSlide(i) = 0
                rad_set_freq(i, rad.ToneSlideFreq(i))
            end if                                       
        end if
    next
            
end sub

sub rad_playnote(channel as ubyte, packed_value as uinteger)
    dim as ubyte octave, note, instrument, effect, effect_value = 0


    note = packed_value and &h0f
    octave = (packed_value shr 4) and 7
    instrument = ((packed_value and &hf000) shr 12) or ((packed_value and &h80) shr 3)
    effect = (packed_value and &h0f00) shr 8
    
    if effect <> 0 then effect_value = (packed_value and &h7f0000) shr 16 
    
    ' check if doing noteslide
    if note <> 0 then
        if effect = 3 then
            rad.ToneSlideFreq(channel) = octave * (&h2ae-&h157) + rad_NoteFreq(note - 1) - &h157
                        
            rad.toneSlide(channel) = 1
            if effect_value <> 0 then rad.ToneSlideSpeed(channel) = effect_value
            return
        end if
    end if

    ' play note
    if note <> 0 then
        ' first key off previous note
        rad.OldA0B0(channel).noteon = 0
        rad_adlib_write(&hb0 + channel, rad.OldA0B0(channel).hi_byte)
        
        if instrument <> 0 then rad_set_volume(channel, 0): rad_load_instrument(channel, instrument)
         
        if note <> 15 then
            rad.OldA0B0(channel).freq = rad_NoteFreq(note-1)
            rad.OldA0B0(channel).octave = octave
            rad.OldA0B0(channel).noteon = 1
            rad_adlib_write(&ha0 + channel, rad.OldA0B0(channel).lo_byte)
            rad_adlib_write(&hb0 + channel, rad.OldA0B0(channel).hi_byte)
        end if
    end if
    
    select case effect
        case 1 ' portamento up
            rad.PortSlide(channel) = effect_value
        case 2 ' portamento down
            rad.PortSlide(channel) = -effect_value
        case 3 ' portamento (no note given)
            if effect_value <> 0 then rad.ToneSlideSpeed(channel) = effect_value
            rad.ToneSlide(channel) = 1
        case 5, &h0a 'tone+volume slide, volume slide
            if effect_value >= 50 then rad.VolSlide(channel) = -(effect_value - 50) else rad.VolSlide(channel) = effect_value
            if effect = 5 then rad.ToneSlide(channel) = 1
        case &h0c ' set volume
            rad_set_volume(channel, effect_value)
        case &h0d ' jump to line
            if effect_value < 64 then rad.pattern_jmp_f = effect_value or &h80
        case &h0f ' set speed
            rad.Speed = effect_value
    end select
    
end sub

sub rad_next_pattern    
    rad.OrderPos += 1    
    if rad.OrderPos = rad.OrderSize then rad.OrderPos = 0
    if (*(rad.pOrderList + rad.OrderPos) and &h80) <> 0 then rad.OrderPos = *(rad.pOrderList + rad.OrderPos) and &h7f
    rad.pPatternPos = rad.pdata + *cast(ushort ptr, rad.pPatternList + *(rad.pOrderList + rad.OrderPos) * 2) 
end sub

sub rad_update_frame

    dim as ubyte ptr p = rad.pPatternPos
    dim as ubyte ch

    if rad.SpeedCnt > 0 then rad.SpeedCnt -= 1: goto _jmp_update 
    ' switch off any effects
    for i as integer = 0 to 8
        rad.ToneSlide(i) = 0
        rad.VolSlide(i) = 0
        rad.PortSlide(i) = 0
    next    
    
    if p <> 0 then 
        'pPatternPos must be set already
        if (*p and &h7f) = rad.CurrentLine then
            if *p and &h80 <> 0 then rad.pPatternPos = 0 ' mark the rest of pattern as blank
            p += 1 '' move to first channel
            do
                ch = *p
                ' play channels
                rad_playnote(ch and &h7f, *cast(uinteger ptr, p + 1))
                
                if (*(p + 2) and &h0f) = 0 then p += 3 else p += 4
                
                ' patternbreak command
                if (rad.pattern_jmp_f and &h80) <> 0 then
                    rad.SpeedCnt = rad.Speed - 1
                    rad.CurrentLine = rad.pattern_jmp_f and &h7f
                    rad_next_pattern()
                    p = rad.pPatternPos
                    while (*p and &h7f) < (rad.pattern_jmp_f and &h7f)
                        if (*p and &h80) <> 0 then
                            rad.pattern_jmp_f = 0
                            rad.pPatternPos = p                            
                            goto _jmp_update
                        end if
                        p += 1
                        while (*p and &h80) = 0
                            if (*(p + 2) and &h0f) = 0 then p += 3 else p += 4
                        wend
                    wend
                    rad.pattern_jmp_f = 0
                    rad.pPatternPos = p
                    goto _jmp_update
                end if
            loop while (ch and &h80) = 0
            rad.pPatternPos = p            
        end if
    end if
    
    ' update pointers
    rad.SpeedCnt = rad.Speed - 1
    rad.CurrentLine += 1
    if rad.CurrentLine >= 64 then rad.CurrentLine = 0 : rad_next_pattern 

_jmp_update:        
    rad_update_notes
       
end sub

sub rad_play(byval ptune as ubyte ptr)
    
    if rad.active = 1 then rad_stop
    
    if *cast(uinteger ptr, ptune) <> &h20444152 then return    
    
    memset(@rad, 0, sizeof(rad_player_data))
    memset(@rad.ToneSlideSpeed(0), 1, 9)

    rad.active = 1
    
    rad.pdata = ptune
    
    ptune += 17
    rad.Speed = *ptune and &h3f
    if (*ptune and &h60) = 0 then framesmpl = freqhz \ 50 else framesmpl = freqhz \ 18
    
    if (*ptune and &h80) <> 0 then
        ptune += 1
        printf !"Description: %s \n", cast(zstring ptr, ptune)
        while *ptune <> 0: ptune +=1: wend
    end if
    
    ptune += 1
    
    while *ptune <> 0
        rad.pInstr(*ptune) = ptune + 1
        ptune += 12
    wend     
    
    ptune += 1
    
    rad.OrderSize = *ptune
    rad.pOrderList = ptune + 1
    ptune += *ptune + 1
      
    rad.pPatternList = ptune
    rad.pPatternPos = rad.pdata + *cast(ushort ptr, rad.pPatternList + *rad.pOrderList * 2)
    'rad.OrderPos = 0
    'rad.SpeedCnt = 0
    'rad.CurrentLine = 0
    
    rad.update = @rad_update_frame
end sub

sub rad_stop
    'if rad.active = 0 then return
    rad.active = 0
    OPL2ResetChip(ym)
    WINMM_reset
end sub


sub playcallback cdecl (byval userdata as any ptr, byval stream as ubyte ptr, byval length as integer)
    static as integer c, cnt = 0
    
    if rad.active = 0 then return
    for c = 0 to buffsmpl - 1
        if cnt >= framesmpl then
            cnt = 0          
            rad.update()
        end if
        OPL2UpdateOne(ym, @buf(c), 1)
        cnt += 1
    next
    memcpy(stream, @buf(0), length)
end sub

sub rad_init
    memset @rad, 0, sizeof(rad_player_data)
    ym = OPL2Init(1, OPL2_INTERNAL_FREQ, freqhz)
    OPL2ResetChip(ym)

    if WINMM_open(cast(USER_CALLBACK, @playcallback), 2048) = FALSE then
        printf "Audio open ERROR"
        sleep
        end 0
    end if
end sub

sub rad_deinit
    rad_stop
    WINMM_Close()
    OPL2Shutdown()
end sub

'' MAIN =================================================================================
#if 0
    if command(1) = "" then
        printf !"Usage: radplay32.exe radfile\n    Press any key!\n"
        sleep
        end
    end if

    scope
        dim as FILE ptr fh
        
        memset @rad, 0, sizeof(rad_player_data)
        'fh = fopen("raster.rad", @"rb")
        fh = fopen(command(1), @"rb")
        fseek(fh, 0, SEEK_END)
        rad.size = ftell(fh) 
        fseek(fh, 0, SEEK_SET)   
        rad.pdata = callocate(rad.size + 2)
        fread rad.pdata, 1, rad.size, fh
        fclose fh
    end scope

    ' exit if wrong rad file
    if peek(uinteger, rad.pdata) <> &h20444152 then
         printf !"Invalid .rad file\n    Press any key!\n"
         sleep  
         end
    end if

    printf !"Now playing, press any key to exit!\n"
    
    ym = OPL2Init(1, OPL2_INTERNAL_FREQ, freqhz)
    OPL2ResetChip(ym)
    
    if WINMM_open(cast(USER_CALLBACK, @playcallback), 2048) = FALSE then
        printf "Audio open ERROR"
        sleep
        end 0
    end if

    rad_play(rad.pdata)
            
    while inkey = ""
        sleep 10 
    wend   

    rad_stop
    
    ' close sound system
    WINMM_Close()
    OPL2Shutdown()

    deallocate(rad.pdata)
#endif    